include "wsdl.grm"

redefine program 
		...
	|	[repeat fact]
end redefine

define fact
	[repeat id_or_id_dot]																			[NL]
end define 

define id_or_id_dot
		[SPOFF] [id] '. [id] '. [id] [SPON]	[SP]
	|	[SPOFF] [id] '. [id] [SPON]	[SP]
	|	[id] [SP]
end define

function main
	replace [program]
		P [program]
	
	construct Service [repeat service]
		_ [^ P] 
	deconstruct Service
		'< _ [opt prefix] 'service AttrList [opt attribute_list] '>
			_ [repeat service_scope] 
		'</ _ [opt prefix] 'service>
	construct ServiceNameAttr [repeat name_attr]
		_ [^ AttrList]
	deconstruct ServiceNameAttr
		_ [opt prefix] 'name = ServiceNameWithPrefix [stringlit] 
		_ [repeat name_attr]
	construct ServiceNameNoPrefix [stringlit] 
		ServiceNameWithPrefix [deletePrefix]
	construct ServiceNameID [id] 
		_ [unquote ServiceNameNoPrefix]
		
	export ServiceName [id]
		ServiceNameID
	
	construct Types [repeat types]
		_ [^ P] 
	construct Elements [repeat schema_element]
		_ [^ Types]
	construct ComplexTypes [repeat complex_type]
		_ [^ Types]
	
	construct Facts [repeat fact]
		_ [getTypes each ComplexTypes]
		
	by 
		Facts
end function 

function getTypes ComplexType [complex_type]
	replace [repeat fact]
		PreviousFacts [repeat fact]
	deconstruct ComplexType
		'< _ [opt prefix] 'complexType AttrList [opt attribute_list] '>
			Contents [repeat complexType_scope]			
		'</ _ [opt prefix] 'complexType>
	construct TypeNameAttr [repeat name_attr]
		_ [^ AttrList]
	deconstruct TypeNameAttr
		_ [opt prefix] 'name = Name [stringlit] 
		_ [repeat name_attr]	
	construct TypeNameNoPrefix [stringlit]
		Name [deletePrefix]
	construct TypeName [id]
		_ [unquote TypeNameNoPrefix]
		
	construct SingletonElements [repeat schema_element]
		_ [^ Contents]
	
	construct NewFacts [repeat fact]
		_ [getSingletonElements TypeName  each SingletonElements]
		
	by 
		PreviousFacts [. NewFacts]
end function

function getSingletonElements ParentElmtName [id] Element [schema_element]
	replace [repeat fact]
		PreviousFacts [repeat fact]
	deconstruct Element
		'< _ [opt prefix] 'element AttrList [opt attribute_list] '/>
	construct ElementNameAttr [repeat name_attr]
		_ [^ AttrList]
	deconstruct ElementNameAttr
		_ [opt prefix] 'name = Name [stringlit] 
		_ [repeat name_attr]	
	construct ElementNameNoPrefix [stringlit]
		Name [deletePrefix]
	construct ElementName [id]
		_ [unquote ElementNameNoPrefix]
	import ServiceName [id]	
	construct NewFact [fact]
		'hasName ServiceName '. ParentElmtName '. ElementName ElementName
	by 
		PreviousFacts [. NewFact]
end function

function deletePrefix 
	replace [stringlit]
		NameWithPrefix [stringlit]
	construct IndexOfColon [number]
		_ [index NameWithPrefix ":"] [+ '1]
	deconstruct not IndexOfColon
		1
	by
		NameWithPrefix [: IndexOfColon 999]
end function
