include "wsdl.grm"

redefine program 
		...
	|	[repeat fact]
end redefine

define fact
	[repeat id_or_id_dot]																			[NL]
end define 

define id_or_id_dot
		[SPOFF] [id] '. [id] '. [id] [SPON]	[SP]
	|	[SPOFF] [id] '. [id] [SPON]	[SP]
	|	[id] [SP]
end define

function main
	replace [program]
		P [program]
	
	construct ServiceElmt [repeat service]
		_ [^ P] 
	deconstruct ServiceElmt
		'< _ [opt prefix] 'service AttrList [opt attribute_list] '>
			_ [repeat service_scope] 
		'</ _ [opt prefix] 'service>
	construct ServiceNameAttr [repeat name_attr]
		_ [^ AttrList]
	deconstruct ServiceNameAttr
		_ [opt prefix] 'name = ServiceNameWithPrefix [stringlit] 
		_ [repeat name_attr]
	construct ServiceNameNoPrefix [stringlit] 
		ServiceNameWithPrefix [deletePrefix]
	construct ServiceName [id] 
		_ [unquote ServiceNameNoPrefix]
	export Service [id]
		ServiceName
		
	construct AllMessages [repeat message]
		_ [^ P]
	export Messages [repeat message]
		AllMessages
		
	construct Types [repeat types]
		_ [^ P] 
	construct SchemaElements [repeat schema_element]
		_ [^ Types]
	export Elements [repeat schema_element]
		SchemaElements
	
	construct PortType [repeat port_type]
		_ [^ P] 
	construct Ops [repeat operation]
		_ [^ PortType]
	
	construct Facts [repeat fact]
		_ [processFaults each Ops]
	
	by 
		Facts
end function 

function processFaults Op [operation]
	replace [repeat fact]
		PreviousFacts [repeat fact]
		
	deconstruct Op
		'< _ [opt prefix] 'operation AttrList [opt attribute_list] '>
			_ [repeat operation_scope]
		'</ _ [opt prefix] 'operation> 
	construct OpNameAttr [repeat name_attr]
		_ [^ AttrList]
	deconstruct OpNameAttr
		_ [opt prefix] 'name = OpNameWithPrefix [stringlit] 
		_ [repeat name_attr]	
	construct OpNameNoPrefix [stringlit] 
		OpNameWithPrefix [deletePrefix]
	construct OpName [id] 
		_ [unquote OpNameNoPrefix]
		
	construct Faults [repeat fault]
		_ [^ Op]
	construct FaultMsgAttr [repeat message_attr]
		_ [^ Faults]
	deconstruct FaultMsgAttr
		_ [opt prefix] 'message = FaultNameWithPrefix [stringlit] 
		_ [repeat message_attr]
	construct FaultNameNoPrefix [stringlit] 
		FaultNameWithPrefix [deletePrefix]
	construct FaultName [id] 
		_ [unquote FaultNameNoPrefix]	
		
	import Messages [repeat message]

	construct Parts [repeat part]
		_ [getMatchingMsgParts FaultName each Messages]
	
	import Elements [repeat schema_element]
	
	construct TypeFacts [repeat fact]
		_ [processPartsWithType FaultName each Parts]
		
	construct ElementFacts [repeat fact]
		_ [processPartsWithElement FaultName each Parts]
	
	construct NewFacts [repeat fact]
		TypeFacts [. ElementFacts]
	
	by 
		PreviousFacts [. NewFacts]
end function

function getMatchingMsgParts Name [id] Msg [message]
	replace [repeat part]
		_ [repeat part]
	deconstruct Msg
		'< _[opt prefix] 'message AttrList [opt attribute_list] '> 
			MsgContents [repeat message_scope] 	
		'</ _ [opt prefix] 'message>
	construct NameAttrs [repeat name_attr]
		_ [^ AttrList]
	deconstruct NameAttrs
		_ [opt prefix] 'name = MsgNameWithPrefix [stringlit] 
		_ [repeat name_attr]	
	construct MsgNameNoPrefix [stringlit] 
		MsgNameWithPrefix [deletePrefix]
	construct MsgName [id] 
		_ [unquote MsgNameNoPrefix]
	deconstruct MsgName
		Name
	construct Parts [repeat part]
		_ [^ MsgContents]
	by 
		Parts
end function

function processPartsWithType FaultName [id] Part [part]
	replace [repeat fact]
		PreviousFacts [repeat fact]
	construct TypeAttrs [repeat type_attr]
		_ [^ Part]
	deconstruct TypeAttrs
		_ [opt prefix] 'type = TypeNameWithPrefix [stringlit] 
		_ [repeat type_attr]
	construct TypeNameNoPrefix [stringlit] 
		TypeNameWithPrefix [deletePrefix]
	construct TypeName [id] 
		_ [unquote TypeNameNoPrefix]
	construct NameAttrs [repeat name_attr]
		_ [^ Part]
	deconstruct NameAttrs
		_ [opt prefix] 'name = NameWithPrefix [stringlit] 
		_ [repeat name_attr]
	construct NameNoPrefix [stringlit] 
		NameWithPrefix [deletePrefix]
	construct Name [id] 
		_ [unquote NameNoPrefix]
	import Service [id]
	construct NewFact [fact]
		'hasParameter Service '. FaultName Service '. FaultName '. Name
	by
		PreviousFacts [. NewFact]
end function

function processPartsWithElement FaultName [id] Part [part]
	replace [repeat fact]
		PreviousFacts [repeat fact]
	construct ElmtAttrs [repeat element_attr]
		_ [^ Part]
	deconstruct ElmtAttrs
		_ [opt prefix] 'element = ElmtNameWithPrefix [stringlit] 
		_ [repeat element_attr]
	construct ElmtNameNoPrefix [stringlit] 
		ElmtNameWithPrefix [deletePrefix]
	construct ElmtName [id] 
		_ [unquote ElmtNameNoPrefix]
	import Elements [repeat schema_element]
	
	construct MatchingElements [repeat schema_element]
		_ [getMatchingElmts ElmtName each Elements]
	
	construct NewFacts [repeat fact]
		_ [processElmts FaultName each MatchingElements]

	by
		PreviousFacts [. NewFacts]
end function

function getMatchingElmts Name [id] Elmt [schema_element]
	replace [repeat schema_element]
		_ [repeat schema_element]
	deconstruct Elmt
		'< _[opt prefix] 'element AttrList [opt attribute_list] '> 
			ElmtContents [repeat schema_scope] 	
		'</ _ [opt prefix] 'element>
	construct NameAttrs [repeat name_attr]
		_ [^ AttrList]
	deconstruct NameAttrs
		_ [opt prefix] 'name = ElmtNameWithPrefix [stringlit] 
		_ [repeat name_attr]	
	construct ElmtNameNoPrefix [stringlit] 
		ElmtNameWithPrefix [deletePrefix]
	construct ElmtName [id] 
		_ [unquote ElmtNameNoPrefix]
	deconstruct ElmtName
		Name
	construct SingletonElements [repeat schema_element]
		_ [^ ElmtContents]
	by 
		SingletonElements
end function

function processElmts FaultName [id] Elmt [schema_element]
	replace [repeat fact]
		PreviousFacts [repeat fact]
	deconstruct Elmt
		'< _[opt prefix] 'element AttrList [opt attribute_list] '/> 
	construct NameAttrs [repeat name_attr]
		_ [^ AttrList]
	deconstruct NameAttrs
		_ [opt prefix] 'name = ElmtNameWithPrefix [stringlit] 
		_ [repeat name_attr]	
	construct ElmtNameNoPrefix [stringlit] 
		ElmtNameWithPrefix [deletePrefix]
	construct ElmtName [id] 
		_ [unquote ElmtNameNoPrefix]
	import Service [id]	
	construct NewFact [fact]
		'hasParameter Service '. FaultName Service '. FaultName '. ElmtName
		
	by 
		PreviousFacts [. NewFact]
end function

function deletePrefix 
	replace [stringlit]
		NameWithPrefix [stringlit]
	construct IndexOfColon [number]
		_ [index NameWithPrefix ":"] [+ '1]
	deconstruct not IndexOfColon
		1
	by
		NameWithPrefix [: IndexOfColon 999]
end function
